<div class="modal-padding mt-3">
    <p class="alert alert-info">
        Il est préférable de ne pas effectuer l'ajout d'un accès utilisateur à
        partir de l'interface d'administration technique, sauf dans les cas où
        il s'agit du premier utilisateur d'un tenant ou en cas de blocage.
    </p>
</div>

{{ form_start(form) }}
<div>
    {{ form_errors(form) }}
</div>
{{ form_row(form.tenant) }}
{{ form_row(form.role) }}
{{ form_row(form.loginType) }}
{{ form_row(form.openid) }}
{{ form_row(form.ldap) }}
<div class="search-engine-container form-group search-engine">
    {{ form_row(form.ldapUsername, {'attr': {'autocomplete': 'off'}}) }}
    <div id="ldap-search" class="dropdown-menu">
        <ul class="search-bar-results"></ul>
    </div>
</div>
<button type="submit" class="btn btn-primary hide">Hidden submit</button>
{{ form_end(form) }}

<script>
    var ldapUsername = $('#{{ form.ldapUsername.vars.id }}');
    var ldapDropdown = $('#ldap-search').dropdown('hide');
    var ldapDropdownResults = ldapDropdown.find('ul');
    var tenantSelect = $('#{{ form.tenant.vars.id }}');
    var roleSelect = $('#{{ form.role.vars.id }}');
    var openidSelect = $('#{{ form.openid.vars.id }}');
    var ldapSelect = $('#{{ form.ldap.vars.id }}');

    var searchButton = $('<button type="button" class="submit-search-engine">')
        .append($('<span class="sr-only">').text("Rechercher"))
        .append($('<i class="fa fa-search" aria-hidden="true">'))
        .on('click', function (event) {
            // .dropdown('toggle') ne fonctionne pas...
            if (ldapDropdown.hasClass('show')) {
                ldapDropdown.dropdown('hide');
            } else {
                ldapDropdown.dropdown('show');
            }
        })
    ;
    searchButton.insertAfter(ldapUsername);

    tenantSelect.on('change', () => {
        let tenant = tenantSelect.find('option:selected').attr('data-baseurl');

        roleSelect.find('option[data-tenant]').each(function () {
            let optionTenant = $(this).attr('data-tenant');
            if (optionTenant === tenant) {
                $(this).enable().parent().enable();
            } else if (optionTenant && optionTenant !== tenant) {
                $(this).disable().parent().disable();
            }
        });

        let filterTenants = function () {
            let select = $(this).closest('select');
            let selectValue = select.val();
            let optionTenants = JSON.parse($(this).attr('data-tenants'));

            if (optionTenants.indexOf(tenant) !== -1) {
                $(this).enable();
                console.log('enable');
            } else if (optionTenants) {
                $(this).disable();
                console.log('disable');
                if (selectValue === $(this).attr('value')) {
                    select.val('').trigger('change');
                }
            }
        };
        openidSelect.find('option[data-tenants]').each(filterTenants);
        ldapSelect.find('option[data-tenants]').each(filterTenants);
    }).change();

    $('#{{ form.loginType.vars.id }}').on('change.user-form', function() {
        let value = $(this).val();
        let form = $(this).closest('form');
        let ldap = form.find('.type-ldap');
        let openid = form.find('.type-openid');

        ldap.hide().find('select, input').disable();
        openid.hide().find('select').disable();
        switch (value) {
            case 'refae':
                break;
            case 'ldap':
                ldap.show().find('select, input').enable();
                ldapUsername.trigger('change.user-form');
                break;
            case 'openid':
                openid.show().find('select, input').enable();
                break;
        }
    }).trigger('change.user-form');

    ldapUsername.on('keyup.user-form change.user-form', function() {
        var value = $(this).val();
        var ldapSelect = $('#{{ form.ldap.vars.id }}');
        var ldapId = ldapSelect.val();
        var ldap = ldapSelect.find('option[value="' + ldapId + '"]').data();
        if (!ldap) {
            return;
        }
        var field = ldap.ldapMapLogin;

        if ($(this).data('last-value') !== value) {
            $(this).data('last-value', value);
        } else {
            return;
        }

        ldapDropdown.dropdown('show');
        ldapDropdownResults
            .empty()
            .append('<li><i aria-hidden="true" class="fa fa-spinner fa-spin animated ml-2"></i></li>');
        if (!value) {
            field = ldap.ldapMapUsername;
            value = $(this).data('username');
        } else if (value.length < 3) {
            return;
        }
        $.ajax({
            url: '{{ url('admin_ldap_search', {'id': '%s'}) }}'.format(ldapId),
            method: 'POST',
            data: {
                field: field,
                value: value,
                tenant: $('#{{ form.tenant.vars.id }}').val(),
            },
            success: function (content) {
                ldapDropdownResults.empty();
                for (let i = 0; i < content.length; i++) {
                    $('<li class="search-result">').text(content).appendTo(ldapDropdownResults);
                }
            },
            complete: function () {
                ldapDropdownResults.find('.fa-spinner').parent().remove();
                if (ldapDropdownResults.find('li').length === 0) {
                    ldapDropdown.dropdown('hide');
                }
            }
        });
    });

    ldapDropdownResults.on('click.selectSearchResult', '.search-result', function(event) {
        event.preventDefault();
        ldapUsername.val($(this).text());

        setTimeout(() => ldapDropdown.dropdown('hide'), 100);
        return false;
    });
</script>
